local mod_gui = require '__core__/lualib/mod-gui'
local items = {"inserter", "transport-belt", "pipe", "pump"}
local on_player_created = function(event)
    local frame = mod_gui.get_frame_flow(game.get_player(event.player_index))

    local testFrame = frame.add{
        type = "frame",
        name = "testFrame",
        direction = "vertical"
    }

    local test1 = testFrame.add{
        type = "frame",
        caption = "Unexpected behaviour (locked/unlocked buttons)",
        name = "test1",
        style = "bordered_frame"
    }

    for i = 1, 4 do
        local b = test1.add{
            type = "choose-elem-button",
            elem_type = "item",
            style = "logistic_button_slot"
        }
        b.elem_value = items[i]
        b.locked = b.elem_value
    end

    local test2 = testFrame.add{
        type = "frame",
        caption = "Expected behaviour (sprite buttons)",
        name = "test2",
        style = "bordered_frame"
    }
    for i = 1, 4 do
        local b = test2.add{
            type = "sprite-button",
            style = "logistic_button_slot"
        }
        b.sprite = "item/" .. items[i]
    end
    testFrame.add{
        type = "button",
        name = "reset",
        caption = "Reset"
    }
end
--logistic_button_selected_slot
script.on_event(defines.events.on_player_created, on_player_created)
script.on_event(defines.events.on_gui_click, function(event)
    local player = game.get_player(event.player_index)
    local testFrame = mod_gui.get_frame_flow(player).testFrame
    local element = event.element

    if element.name == "reset" then
        testFrame.destroy()
        global.selected = nil
        global.selected2 = nil
        on_player_created(event)
        return
    end
    if element.type ~= "sprite-button" and element.type ~= "choose-elem-button" then return end

    --Works as expected for sprite buttons
    if element.parent.name == "test2" then
        if not global.selected2 then
            element.style = "logistic_button_selected_slot"
            global.selected2 = element
        elseif global.selected2 and global.selected2 ~= element then--
            global.selected2.style = "logistic_button_slot"
            global.selected2 = element
            element.style = "logistic_button_selected_slot"
        end
        return
    end

    --Same code as above, except that the buttons are choose-elem-buttons and the clicked button gets unlocked
    if not global.selected then--select button, lock it
        element.style = "logistic_button_selected_slot"
        element.locked = false
        global.selected = element
    elseif global.selected and global.selected ~= element then--
        global.selected.style = "logistic_button_slot"
        global.selected.locked = true
        global.selected = element
        element.style = "logistic_button_selected_slot"
        element.locked = false
    end
end)